<p align="right">
<a href="../en/plugins-options.md">English description</a> | Описание на русском
</p>

# Конфигурирование плагинов

В TARS версии 1.8.0 и выше появилась возможность конфигурировать почти все плагины (gulp-плагины и не только) в отдельном файле, plugins-config.json в корне проекта. Раньше для этого требовалось переопределять таск, в котором используется плагин, а иногда править файлы самого сборщика.

Изменять можно 100% опций, но некоторые из плагинов должны быть настроены определенным образом, чтобы TARS работал корректно. Каждая такая опция описана в комментариях в plugins-config.json **Рекомендуется не менять их!** 

plugins-config.json — не просто json-файл. В нем вы можете использовать комментарии, и специальное выражение insert(). Об этом чуть подробнее.

Некоторые конфиги зависят от текущего tars-config, например, base-dir для gulp-jade. Чтобы вам не приходилось менять это руками каждый раз при смене имени папки с компонентами, вы можете написать так:
```js
"gulp-jade": {
    "pretty": true,
    "basedir": "markup/insert(tars.config.fs.componentsFolderName)"
}
```

В этом случае, insert(tars.config.fs.componentsFolderName) будет заменено на то, что у вас находится в tars-config для componentsFolderName. Внутри insert() вы можете выполнить любую JavaScript функцию. **Важно обернуть insert() в кавычки сразу, чтобы JSON распарсился корректно. Не забудьте экранировать двойные кавычки, если они используются!**

Пример с gulp-jade будет интерпретирован следующим образом:
```js
"gulp-jade": {
    "pretty": true,
    "basedir": "markup/components"
}


Пару примеров использования insert():
```js
"example-plugin": {
    "option": "insert(function() {return 'tars'})"
}
```

В итоге получим:
```js
"example-plugin": {
    "option": "tars"
}
```

