<p align="right">
<a href="../en/tasks-and-watchers.md">English description</a> | Описание на русском
</p>

# Работа с тасками и вотчерами

TARS – набор gulp-тасков, организованных особым образом. Каждый таск — отдельный файл (кроме составных, таких как build, dev и т.п.), в котором описывается последовательность действий над набором файлов. Также в TARS присутствуют вотчеры, которые позволяют запускать таски при изменении какого-либо файла. Таски и вотчеры бывают системные (встроенные в TARS по умолчанию) и пользовательские, с помощью которых можно расширить функциональность TARS.

В общем виде работа TARS в режиме разработки выглядит следующим образом:

* при запуске запускаются все таски, которые требуются для сборки проекта;
* после сборки запускаются вотчеры, которые будут следить за изменениями файлов и запускать определенные таски.

Встроенные таски находятся в `tars/tasks`, разбиты по папкам в зависимости от типа таска. Встроенные вотчеры для тасков находятся в `tars/watchers`. Вы можете добавлять любые свои таски/вотчеры и размещать их в `tars/user-tasks`/`tars/user-watchers`.

При добавлении тасков и вотчеров рекомендуется использовать:
* tars.config.fs.staticFolderName — для имени папки со статикой;
* tars.config.fs.imagesFolderName — для имени папки с изображениями;
* tars.templater.ext – содержит расширения для файлов выбранного шаблонизатора;
* tars.cssPreproc.ext – содержит расширения для файлов выбранного css-препроцессора.

Если вам требуется заменить какой-либо встроенный таск/вотчер, вам необходимо назвать его также, как тот таск/вотчер, который необходимо заменить. Важно соблюсти вложенность папок. Пример, справедливый как для тасков, так и для вотчеров, доступен вот такой встроенный таск:

```
tars/tasks/html/minify-html.js
```

Необходимо, чтобы вместо встроенного `minify-html.js` подключался пользовательский. Для этого необходимо в папке `user-tasks` повторить ту же файловую структуру для файла таска и использовать такое же имя для самого таска:

```
tars/user-tasks/html/minify-html.js
```

В этом случае в gulpfile.js будет подключен не встроенный, а пользовательский таск.

Также есть возможность отключить любой таск/вотчер, просто добавив знак `_` в начало названия этого таска/вотчера.

Если вам требуется встроить пользовательский таск в уже существующую цепочку других тасков, например необходимо выполнять вашу задачу в рамках dev-таска, то необходимо переопределить dev-таск, указав именно ту цепочку задач, которая подойдет именно вам.

Больше подробностей вы можете получить в соответствующих разделах документации о [тасках](tasks.md) и [вотчерах](watchers.md).
